/* ogmmerge.h
**
*/

#ifndef __ogmmerge_H__
#define __ogmmerge_H__

#include <ogg/ogg.h>

typedef struct {
  ogg_page *og;
  u_int64_t timestamp;
} ogmmerge_page_t;

typedef struct {
   void *private;
   char *name;
} ogmmerge_state_t;

typedef struct filelist_tag {
  char *name;
  FILE *fp;

  int type;

  int dontread;

  ogmmerge_state_t state;
  ogmmerge_page_t *page;
  int status;
  unsigned serialno;

  char *atracks;
  char *vtracks;

  int (*state_init)(ogmmerge_state_t *state, int serialno, char *atracks,
                    char *vtracks);
  int (*data_in)(ogmmerge_state_t *state, char *buffer, unsigned long size);
  ogmmerge_page_t *(*page_out)(ogmmerge_state_t *state);

  struct filelist_tag *next;
} filelist_t;

typedef struct {
   char *outfile;
   FILE *out;
   filelist_t *input;
   int verbose;
} param_t;

/* errors */
#define EMOREDATA -1
#define EMALLOC -2
#define EBADHEADER -3
#define EBADEVENT -4
#define EOTHER -5

/* types */
#define TYPEUNKNOWN   0
#define TYPEVORBIS    1
#define TYPEAVI       2
#define TYPEWAV       3 

#endif  /* __ogmmerge_H__ */

